<?php

//
// This plugin integrates webcalng into Squirrelmail.
// Plugin Version 1.0
//

include_once("webcalng_functions.php");
define('SM_PATH','../../');
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'include/load_prefs.php');

// If the user is logged into webcalng, then just redirect them to
// their calendar.  Otherwise, display a form to let them setup 
// access to webcalng.

global $webcalng_webcal, $webcalng_http, $webcalng_http_host,
       $webcalng_calendar, $webcalng_sq_secret;

// Read in webcalng config file.
webcalng_read_config();

// If we are logged in, redirect the user to their calendar when they click
// on the webcalng link in the header.  Otherwise, display a form that lets
// them setup access to a webcalng calendar from SquirrelMail.
sqgetGlobalVar('webcalng_logged_in',$webcalng_logged_in);
if ($webcalng_logged_in == 1) {
    redirect_to_webcalng();
} else {
    // Either save the form data, or display it if nothing has been POSTed.
    if (isset($_POST['calendar'])) {
        save_webcalng_connect_data();
    } else {
        display_webcalng_connect_form();
    }
}

// This function just redirects the usr to their webcalng calendar,
// since they have succesfully auto-logged in to webcalng.
function redirect_to_webcalng () {
    global $webcalng_webcal, $webcalng_http, $webcalng_http_host,
           $webcalng_calendar, $webcalng_sq_secret, $data_dir;

    sqgetGlobalVar('username', $username, SQ_SESSION);
    $webcalng_calendar = getPref($data_dir, $username, 'webcalng_calendar');
    $webcalng_calendar = preg_replace("/\s+/", "+", $webcalng_calendar);
    $url = $webcalng_http . $webcalng_http_host . $webcalng_webcal . "?calendar=" . $webcalng_calendar . "&op=month";
    header("Location: $url");
}

// This function shows the user the form used to create a connection between
// SquirrelMail and webcalng.
function display_webcalng_connect_form () {
    global $color;

    displayPageHeader($color, 'None');
    sqgetGlobalVar('username', $username, SO_SESSION);
    $webcalng_calendar = getPref($data_dir, $username, 'webcalng_calendar');

        echo "
<BR><BR>
<FORM METHOD=post>
<INPUT TYPE=hidden NAME=squser VALUE=\"$username\">
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR=$color[7] ALIGN=center WIDTH=80%>
<TR>
  <TD>
    <TABLE BORDER=0 CELLSPACING=1 CELLPADDING=20 BGCOLOR=$color[7] ALIGN=center>
    <TR>
      <TD BGCOLOR=#ffffff ALIGN=center>
        <TABLE>
        <TR>
          <TD COLSPAN=2 ALIGN=center>
            <B>Configure connection to webcalng</B>
          </TD>
        </TR>
        <TR><TD COLSPAN=2>&nbsp;</TD></TR>
        <TR>
          <TD BGCOLOR=#DDDDDD WIDTH=66%>
            <FONT SIZE=-1>Enter the webcalng calendar to connect to when signing on to SquirrelMail.  If the given calendar does not exist, it will be created.</FONT>
          </TD>
          <TD>
            <INPUT TYPE=text NAME=calendar VALUE=\"$webcalng_calendar\" SIZE=20 MAXLENGTH=50>
          </TD>
        </TR>
        <TR>
          <TD BGCOLOR=#DDDDDD WIDTH=66%>
            <FONT SIZE=-1>Enter the webcalng user that owns the given calendar.  If you are creating a new calendar, use your SquirrelMail username.</FONT>
          </TD>
          <TD>
            <INPUT TYPE=text NAME=givenuser VALUE=\"$username\">
          </TD>
        </TR>
        <TR>
          <TD BGCOLOR=#DDDDDD WIDTH=66%>
            <FONT SIZE=-1>Enter the password for the webcalng user that owns the given calendar.  If you are creating a new calendar, use your Squirrelmail password.</FONT>
          </TD>
          <TD>
            <INPUT TYPE=password NAME=password>
          </TD>
        </TR>
        <TR>
          <TD BGCOLOR=#DDDDDD WIDTH=66%>
            <FONT SIZE=-1>Enter the password again.</FONT>
          </TD>
          <TD>
            <INPUT TYPE=password NAME=password2>
          </TD>
        </TR>
        <TR>
          <TD BGCOLOR=#DDDDDD WIDTH=66%>
            <FONT SIZE=-1>Your SquirrelMail username.</FONT>
          </TD>
          <TD>
            <FONT SIZE=-1>$username</FONT>
          </TD>
        </TR>
        <TR>
          <TD>&nbsp;</TD>
          <TD>
            <INPUT TYPE=submit>
          </TD>
        </TR>
        </TABLE>
      </TD>
    </TR>
    </TABLE>
  <TD/>
</TR>
</TABLE>  
</FORM>
    ";
}

// This function talks to webcalng to verify the data submitted from
// the connection form.  It then sets up SquirrelMail and webcalng as
// needed to support the automatic login into webcalng.
function save_webcalng_connect_data() {
    global $webcalng_webcal, $webcalng_http, $webcalng_http_host,
           $webcalng_calendar, $webcalng_sq_secret, $color, $data_dir;

    displayPageHeader($color, 'None');
    
    // Get form input.
    sqgetGlobalVar('calendar',$calendar);
    sqgetGlobalVar('givenuser',$givenuser);
    sqgetGlobalVar('squser',$squser);
    sqgetGlobalVar('password',$password);
    sqgetGlobalVar('password2',$password2);

    // Verify password was typed correctly twice.
    $result  = "";
    $message = "";
    $link    = "webcalng.php";
    if ($password != $password2) {
        $message = "Passwords did not match.";
    } else {
        // Connect to webcalng with data.  We go through a little pain here in order to make
        // sure that we are not passing a plaintext password via a http GET request, as no one
        // likes their password to show up in log files.
        $sqseed    = time();
        $sqkeyseed = $webcalng_sq_secret . $sqseed;
        $sqkey     = md5($sqkeyseed);
        $orig_cal  = $calendar;
        $calendar  = preg_replace("/\s+/", "+", $calendar);

        // Get the salt used in webcalng to encrypt the password for the
        // given user.  If we get back no salt, then we know that the given
        // user does not exist in webcalng.
        // Hard code this to http for now, as the file function does
        // not seem to support https.  Should be no problem as this
        // connection to webcalng is not really going over the network.
        $url       = "http://" . $webcalng_http_host . $webcalng_webcal . "?op=sqgetsalt" . "&givenuser=" . $givenuser . "&sqseed=" . $sqseed . "&sqkey=" . $sqkey;
        $lines     = file ($url);
	$result    = "";
        foreach ($lines as $line) {
            if (preg_match ('/=/', $line)) {
                list ($key, $value) = preg_split ('/=/', $line);
                if ($key == "RESULT")
                    $result = $value;
            }
        }
        $crypted_password = "";
        if (preg_match('/SALT:OK:/', $result)) {
            list ($dummy1,$dummy2,$salt) = preg_split ('/:/', $result);
            if (preg_match('/^.{2}$/', $salt)) {
                // This is what we get back if the user exists in webcalng.
                $crypted_password = crypt($password, $salt);
            } elseif ($salt == "NOUSER") {
                // The user did not exist in the webcalng, so create our
                // own salt to encrypt the password with.
                $salt = "12";
                $crypted_password = crypt($password, $salt);
            } else {
                // This would be unexpected.  Basically a noop here.
                $crypted_password = "";
            }
        }

        // Continue with setup, passing in the encypted password for the check.
	if ($crypted_password) {
            // Hard code this to http for now, as the file function does
            // not seem to support https.  Should be no problem as this
            // connection to webcalng is not really going over the network.
            $url       = "http://" . $webcalng_http_host . $webcalng_webcal . "?op=sqconnection&sqcalendar=" . $calendar . "&givenuser=" . $givenuser . "&crypted_password=" . $crypted_password . "&squser=" . $squser . "&pwhash=" . $validhash . "&sqseed=" . $sqseed . "&sqkey=" . $sqkey;
            $lines     = file ($url);
	    $result    = "";
            foreach ($lines as $line) {
                if (preg_match ('/=/', $line)) {
                    list ($key, $value) = preg_split ('/=/', $line);
                    if ($key == "RESULT")
                        $result = $value;
                }
            }
        } else {
            $result = "UNKNOWN ERROR!";
        }

        // Determine if the configuration of webcalng was successfull.
        if ($result == "OK") {
            $message = "Connection configured successfully!  You must logout of SquirrelMail and the login again for the changes to take effect.";
            $link = "../../src/signout.php";
            sqgetGlobalVar('username', $username, SO_SESSION);
            setPref($data_dir, $username, 'webcalng_calendar', $orig_cal);
        } elseif ($result == "BADPW") {
            $message = "The given password is not correct for the given webcalng username.";
        } elseif ($result == "NOTOWNER") {
            $message = "The given webcalng username is not the owner of the given webcalng calendar.";
        } elseif ($result == "BADCALNAME") {
            $message = "The given webcalng calendar name has invalid characters in it.";
        } elseif ($result == "BADUSERNAME") {
            $message = "The given webcalng username has invalid characters in it.";
        } else {
            $message = "Unexpected Error code.";
        }
    }

    // Display output.
    echo "
<BR><BR>
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 BGCOLOR=$color[7] ALIGN=center>
<TR>
  <TD>
    <TABLE BORDER=0 CELLSPACING=1 CELLPADDING=20 BGCOLOR=$color[7] ALIGN=center>
    <TR>
      <TD BGCOLOR=#ffffff ALIGN=center>
        <TABLE>
        <TR>
          <TD ALIGN=center>
            <B>$message</B>
            <BR>
            <BR>
            <A HREF=\"$link\" CLASS=navlinks>OK</A>
          </TD>
        </TR>
        </TABLE>
      </TD>
    </TR>
    </TABLE>
  <TD/>
</TR>
</TABLE>  
    ";

}

?>
